/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsILDAPService.idl
 */

#ifndef __gen_nsILDAPService_h__
#define __gen_nsILDAPService_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsILDAPServer; /* forward declaration */

class nsILDAPConnection; /* forward declaration */

class nsILDAPMessageListener; /* forward declaration */


/* starting interface:    nsILDAPService */
#define NS_ILDAPSERVICE_IID_STR "69de6fbc-2e8c-4482-bf14-358d68b785d1"

#define NS_ILDAPSERVICE_IID \
  {0x69de6fbc, 0x2e8c, 0x4482, \
    { 0xbf, 0x14, 0x35, 0x8d, 0x68, 0xb7, 0x85, 0xd1 }}

class NS_NO_VTABLE nsILDAPService : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ILDAPSERVICE_IID)

  /* void addServer (in nsILDAPServer aServer); */
  NS_IMETHOD AddServer(nsILDAPServer *aServer) = 0;

  /* void deleteServer (in wstring aKey); */
  NS_IMETHOD DeleteServer(const char16_t * aKey) = 0;

  /* nsILDAPServer getServer (in wstring aKey); */
  NS_IMETHOD GetServer(const char16_t * aKey, nsILDAPServer * *_retval) = 0;

  /* void requestConnection (in wstring aKey, in nsILDAPMessageListener aListener); */
  NS_IMETHOD RequestConnection(const char16_t * aKey, nsILDAPMessageListener *aListener) = 0;

  /* nsILDAPConnection getConnection (in wstring aKey); */
  NS_IMETHOD GetConnection(const char16_t * aKey, nsILDAPConnection * *_retval) = 0;

  /* void releaseConnection (in wstring aKey); */
  NS_IMETHOD ReleaseConnection(const char16_t * aKey) = 0;

  /* void reconnectConnection (in wstring aKey, in nsILDAPMessageListener aListener); */
  NS_IMETHOD ReconnectConnection(const char16_t * aKey, nsILDAPMessageListener *aListener) = 0;

  /* AUTF8String createFilter (in unsigned long aMaxSize, in AUTF8String aPattern, in AUTF8String aPrefix, in AUTF8String aSuffix, in AUTF8String aAttr, in AUTF8String aValue); */
  NS_IMETHOD CreateFilter(uint32_t aMaxSize, const nsACString & aPattern, const nsACString & aPrefix, const nsACString & aSuffix, const nsACString & aAttr, const nsACString & aValue, nsACString & _retval) = 0;

  /* void parseDn (in string dn, out AUTF8String rdn, out AUTF8String baseDn, out unsigned long rdnCount, [array, size_is (rdnCount), retval] out string rdnAttrs); */
  NS_IMETHOD ParseDn(const char * dn, nsACString & rdn, nsACString & baseDn, uint32_t *rdnCount, char * **rdnAttrs) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsILDAPService, NS_ILDAPSERVICE_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSILDAPSERVICE \
  NS_IMETHOD AddServer(nsILDAPServer *aServer) override; \
  NS_IMETHOD DeleteServer(const char16_t * aKey) override; \
  NS_IMETHOD GetServer(const char16_t * aKey, nsILDAPServer * *_retval) override; \
  NS_IMETHOD RequestConnection(const char16_t * aKey, nsILDAPMessageListener *aListener) override; \
  NS_IMETHOD GetConnection(const char16_t * aKey, nsILDAPConnection * *_retval) override; \
  NS_IMETHOD ReleaseConnection(const char16_t * aKey) override; \
  NS_IMETHOD ReconnectConnection(const char16_t * aKey, nsILDAPMessageListener *aListener) override; \
  NS_IMETHOD CreateFilter(uint32_t aMaxSize, const nsACString & aPattern, const nsACString & aPrefix, const nsACString & aSuffix, const nsACString & aAttr, const nsACString & aValue, nsACString & _retval) override; \
  NS_IMETHOD ParseDn(const char * dn, nsACString & rdn, nsACString & baseDn, uint32_t *rdnCount, char * **rdnAttrs) override; 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSILDAPSERVICE(_to) \
  NS_IMETHOD AddServer(nsILDAPServer *aServer) override { return _to AddServer(aServer); } \
  NS_IMETHOD DeleteServer(const char16_t * aKey) override { return _to DeleteServer(aKey); } \
  NS_IMETHOD GetServer(const char16_t * aKey, nsILDAPServer * *_retval) override { return _to GetServer(aKey, _retval); } \
  NS_IMETHOD RequestConnection(const char16_t * aKey, nsILDAPMessageListener *aListener) override { return _to RequestConnection(aKey, aListener); } \
  NS_IMETHOD GetConnection(const char16_t * aKey, nsILDAPConnection * *_retval) override { return _to GetConnection(aKey, _retval); } \
  NS_IMETHOD ReleaseConnection(const char16_t * aKey) override { return _to ReleaseConnection(aKey); } \
  NS_IMETHOD ReconnectConnection(const char16_t * aKey, nsILDAPMessageListener *aListener) override { return _to ReconnectConnection(aKey, aListener); } \
  NS_IMETHOD CreateFilter(uint32_t aMaxSize, const nsACString & aPattern, const nsACString & aPrefix, const nsACString & aSuffix, const nsACString & aAttr, const nsACString & aValue, nsACString & _retval) override { return _to CreateFilter(aMaxSize, aPattern, aPrefix, aSuffix, aAttr, aValue, _retval); } \
  NS_IMETHOD ParseDn(const char * dn, nsACString & rdn, nsACString & baseDn, uint32_t *rdnCount, char * **rdnAttrs) override { return _to ParseDn(dn, rdn, baseDn, rdnCount, rdnAttrs); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSILDAPSERVICE(_to) \
  NS_IMETHOD AddServer(nsILDAPServer *aServer) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddServer(aServer); } \
  NS_IMETHOD DeleteServer(const char16_t * aKey) override { return !_to ? NS_ERROR_NULL_POINTER : _to->DeleteServer(aKey); } \
  NS_IMETHOD GetServer(const char16_t * aKey, nsILDAPServer * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetServer(aKey, _retval); } \
  NS_IMETHOD RequestConnection(const char16_t * aKey, nsILDAPMessageListener *aListener) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RequestConnection(aKey, aListener); } \
  NS_IMETHOD GetConnection(const char16_t * aKey, nsILDAPConnection * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetConnection(aKey, _retval); } \
  NS_IMETHOD ReleaseConnection(const char16_t * aKey) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ReleaseConnection(aKey); } \
  NS_IMETHOD ReconnectConnection(const char16_t * aKey, nsILDAPMessageListener *aListener) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ReconnectConnection(aKey, aListener); } \
  NS_IMETHOD CreateFilter(uint32_t aMaxSize, const nsACString & aPattern, const nsACString & aPrefix, const nsACString & aSuffix, const nsACString & aAttr, const nsACString & aValue, nsACString & _retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->CreateFilter(aMaxSize, aPattern, aPrefix, aSuffix, aAttr, aValue, _retval); } \
  NS_IMETHOD ParseDn(const char * dn, nsACString & rdn, nsACString & baseDn, uint32_t *rdnCount, char * **rdnAttrs) override { return !_to ? NS_ERROR_NULL_POINTER : _to->ParseDn(dn, rdn, baseDn, rdnCount, rdnAttrs); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsLDAPService : public nsILDAPService
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSILDAPSERVICE

  nsLDAPService();

private:
  ~nsLDAPService();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsLDAPService, nsILDAPService)

nsLDAPService::nsLDAPService()
{
  /* member initializers and constructor code */
}

nsLDAPService::~nsLDAPService()
{
  /* destructor code */
}

/* void addServer (in nsILDAPServer aServer); */
NS_IMETHODIMP nsLDAPService::AddServer(nsILDAPServer *aServer)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void deleteServer (in wstring aKey); */
NS_IMETHODIMP nsLDAPService::DeleteServer(const char16_t * aKey)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsILDAPServer getServer (in wstring aKey); */
NS_IMETHODIMP nsLDAPService::GetServer(const char16_t * aKey, nsILDAPServer * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void requestConnection (in wstring aKey, in nsILDAPMessageListener aListener); */
NS_IMETHODIMP nsLDAPService::RequestConnection(const char16_t * aKey, nsILDAPMessageListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsILDAPConnection getConnection (in wstring aKey); */
NS_IMETHODIMP nsLDAPService::GetConnection(const char16_t * aKey, nsILDAPConnection * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void releaseConnection (in wstring aKey); */
NS_IMETHODIMP nsLDAPService::ReleaseConnection(const char16_t * aKey)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void reconnectConnection (in wstring aKey, in nsILDAPMessageListener aListener); */
NS_IMETHODIMP nsLDAPService::ReconnectConnection(const char16_t * aKey, nsILDAPMessageListener *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* AUTF8String createFilter (in unsigned long aMaxSize, in AUTF8String aPattern, in AUTF8String aPrefix, in AUTF8String aSuffix, in AUTF8String aAttr, in AUTF8String aValue); */
NS_IMETHODIMP nsLDAPService::CreateFilter(uint32_t aMaxSize, const nsACString & aPattern, const nsACString & aPrefix, const nsACString & aSuffix, const nsACString & aAttr, const nsACString & aValue, nsACString & _retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void parseDn (in string dn, out AUTF8String rdn, out AUTF8String baseDn, out unsigned long rdnCount, [array, size_is (rdnCount), retval] out string rdnAttrs); */
NS_IMETHODIMP nsLDAPService::ParseDn(const char * dn, nsACString & rdn, nsACString & baseDn, uint32_t *rdnCount, char * **rdnAttrs)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsILDAPService_h__ */
